;												
; ADC-OSCCAL ATmega8							
; Bernhard.Erfurt@gmx.de						
; 01.01/2013									
;												

; ATmega8 										
.include "m8def.inc"

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=0x0060			; 0x0060 START Adresse 		

; REGISTER										
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				


RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111	; LEDs
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				


rcall CTC_INITIALISIEREN
rcall ADC_INITIALISIERUNG




; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	; ADC		
	rcall ADC_MESSEN
	; OSCCAL	
	out OSCCAL,temp
	; LEDs		
	com temp
	OUT PORTD,temp

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
CTC_INITIALISIEREN:
;Port B				
	sbi DDRB, 1	;(OC1A)

; Frequenz einstellen	
    ldi     temp,high(0)                 
    out     ocr1AH, temp             
  	ldi     temp,low(0)
   	out     ocr1AL,temp              
;  Compare Output Mode 
   ldi temp, (1<<com1A0)
   out TCCR1A,temp

; Vorteiler													
; cs12 cs11 cs10											
;	0 	0 	0 	No clock source. (Timer/Counter stopped)	
; *	0 	0 	1 	clkI/O/1 (No prescaling)					
;	0 	1 	0 	clkI/O/8 (From prescaler)					
;	0 	1 	1 	clkI/O/64 (From prescaler)					
;	1 	0 	0 	clkI/O/256 (From prescaler)					
;	1 	0 	1 	clkI/O/1024 (From prescaler) 				
   ldi     temp,(1<<wgm12|0<<cs12|0<<cs11|1<<cs10)  
   out     tccr1B,temp


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_INITIALISIERUNG:
;														
; ADC initialisieren mit "Free Run" und Vorteiler		
;														
; 	ADEN: ADC Enable                             		
; 	ADSC: ADC Start Conversion                   		
; 	ADFR: ADC Free Running Select                		
; 	ADIF: ADC Interrzpt Flag                     		
; 	ADIE: ADC Interrupt Enable                   		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
;														
;	ADPS2 ADPS1 ADPS0 Division Factor					
;	0 		0 	0 		2								
;	0 		0 	1 		2								
;	0 		1 	0 		4								
;	0 		1 	1 		8								
;	1 		0 	0 		16								
;	1 		0 	1	 	32								
; *	1 		1 	0 		64								
;	1 		1 	1 		128								
;														
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)) 
	out ADCSR, temp
;																					
; ADC REFERENZ																		
;																					
; REFS1 REFS0 Voltage Reference Selection											
;  0     0    AREF, Internal Vref turned off										
; *0     1    AVCC with external capacitor at AREF pin								
;  1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
	ldi temp, (0<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_MESSEN:

	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, 0			; KANAL 0	
	out ADMUX, temp

MESSEN_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp MESSEN_w
MESSEN_SCHLEIFE:                
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
MESSEN_SCHLEIFE_w:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt	
	rjmp MESSEN_SCHLEIFE_w
; ADC einlesen:																
	in  temp, ADCL 			; immer zuerst LOW Byte lesen
	in  temp1, ADCH 			; danach das mittlerweile gesperrte High Byte

	LSR temp1
	ROR temp

	LSR temp1
	ROR temp


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




